Loading...
Searching...
No Matches
Message Body
Headers

The payload object contains the message body. More...

## Macros

#define | MSG_PAYLOAD_INIT()
| Initializer for structure msg_payload_t.

## Typedefs

typedef struct msg_payload_s | msg_payload_t
| The structure msg_payload_t contains representation of MIME message payload.

## Enumerations

enum | { msg_payload_hash }

## Functions

msg_payload_t * | msg_payload_init (msg_payload_t x[1])
| Initialize a structure msg_payload_t.
int | msg_is_payload (msg_header_t const *header)
| Test if header object is instance of msg_payload_t.
msg_payload_t * | msg_payload_dup (su_home_t *home, msg_payload_t const *header))
| Duplicate (deep copy) `msg_payload_t`.
msg_payload_t * | msg_payload_copy (su_home_t *home, msg_payload_t const *header))
| Copy a msg_payload_t header structure.
msg_payload_t * | msg_payload_make (su_home_t *home, char const *s)
| Make a header structure msg_payload_t.
msg_payload_t * | msg_payload_format (su_home_t *home, char const *fmt,...)))
| Make a message payload from formatting result.

## Variables

msg_parse_f | msg_payload_d
| Parse a message payload.
msg_print_f | msg_payload_e
| Print a message payload.
msg_hclass_t | msg_payload_class []
| Header class for message payload.

## Detailed Description

The payload object contains the message body.

The message body has no structure, but it is stored in the pl_data buffer as a byte array. Multiple payload objects may be linked to a list.

## Macro Definition Documentation

## MSG_PAYLOAD_INIT

#define MSG_PAYLOAD_INIT | ( |  | ) |

Initializer for structure msg_payload_t.

A static msg_payload_t structure must be initialized with the MSG_PAYLOAD_INIT() macro. For instance,

msg_payload_t msg_payload = MSG_PAYLOAD_INIT;
msg_payload_t
struct msg_payload_s msg_payload_t
The structure msg_payload_t contains representation of MIME message payload.
Definition msg_types.h:92
MSG_PAYLOAD_INIT
#define MSG_PAYLOAD_INIT()
Initializer for structure msg_payload_t.
Definition msg_protos.h:838

## Typedef Documentation

## msg_payload_t

typedef struct msg_payload_s msg_payload_t

The structure msg_payload_t contains representation of MIME message payload.

The msg_payload_t is defined as follows:

typedef struct msg_payload_s {
msg_common_t pl_common[1]; // Common fragment info
msg_header_t *pl_next; // Next payload object
char *pl_data; // Data - may contain zero bytes
usize_t pl_len; // Length of message payload
} msg_payload_t;
msg_header_t
MSG_HDR_T msg_header_t
Any protocol-specific header object.
Definition msg_types.h:87
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_payload_s
Message payload.
Definition msg_types.h:214
msg_payload_s::pl_next
msg_payload_t * pl_next
Next payload chunk.
Definition msg_types.h:216
msg_payload_s::pl_len
usize_t pl_len
Length of message payload.
Definition msg_types.h:218
msg_payload_s::pl_data
char * pl_data
Data - may contain NUL.
Definition msg_types.h:217
msg_payload_s::pl_common
msg_common_t pl_common[1]
Common fragment info.
Definition msg_types.h:215

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_payload_hash | Hash of message payload.

## Function Documentation

## msg_is_payload()

int msg_is_payload | ( | msg_header_t const * | header | ) |

inline

Test if header object is instance of msg_payload_t.

The function msg_is_payload() returns true (nonzero) if the header class is an instance of message payload object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_payload() returns true (nonzero) if the header object is an instance of header payload and false (zero) otherwise.

## msg_payload_copy()

msg_payload_t * msg_payload_copy | ( | su_home_t * | home,
|  | msg_payload_t const * | header )

inline

Copy a msg_payload_t header structure.

The function msg_payload_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  payload = msg_payload_copy(home, msg->msg_payload);
  msg_payload_copy
  msg_payload_t * msg_payload_copy(su_home_t *home, msg_payload_t const *header))
  Copy a msg_payload_t header structure.
  Definition msg_protos.h:969

Returns
  The function msg_payload_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_payload_dup()

msg_payload_t * msg_payload_dup | ( | su_home_t * | home,
|  | msg_payload_t const * | header )

inline

Duplicate (deep copy) `msg_payload_t`.

The function msg_payload_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  payload = msg_payload_dup(home, msg->msg_payload);
  msg_payload_dup
  msg_payload_t * msg_payload_dup(su_home_t *home, msg_payload_t const *header))
  Duplicate (deep copy) msg_payload_t.
  Definition msg_protos.h:923

Returns
  The function msg_payload_dup() returns a pointer to the newly duplicated msg_payload_t header structure, or NULL upon an error.

## msg_payload_format()

msg_payload_t * msg_payload_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a message payload from formatting result.

The function msg_payload_format() makes a new message payload object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function msg_payload_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_payload_init()

msg_payload_t * msg_payload_init | ( | msg_payload_t | x[1] | ) |

inline

Initialize a structure msg_payload_t.

An msg_payload_t structure can be initialized with the msg_payload_init() function/macro. For instance,

msg_payload_t msg_payload;
msg_payload_init(&msg_payload);
msg_payload_init
msg_payload_t * msg_payload_init(msg_payload_t x[1])
Initialize a structure msg_payload_t.
Definition msg_protos.h:855

Parameters

  x | pointer to msg_payload_t structure

## msg_payload_make()

msg_payload_t * msg_payload_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_payload_t.

The function msg_payload_make() makes a new msg_payload_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling msg_header_make().

Returns
  The function msg_payload_make() returns a pointer to newly maked msg_payload_t header structure, or NULL upon an error.

## Variable Documentation

## msg_payload_class

msg_hclass_t msg_payload_class[]

extern

Header class for message payload.

The header class msg_payload_class defines how a message payload header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_payload_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.